import  java.io.*;
import  java.util.Scanner;

class binaryRec {

  public static void printArray(int a[]) {
	int i;
        System.out.print("[ ");
	for(i = 0; i < a.length; i++)
	    System.out.print(a[i] + " ");
	System.out.println("]");
  }
    
    public static void printSubArray(int a[],int l,int r) {
	int i;
        System.out.print("[ ");
	for(i = 0; i < a.length; i++)
	    if (i >= l && i <= r) 
	       System.out.print(a[i] + " ");
            else
	       System.out.print("   ");
	System.out.println("]");
  }
    
    
  public static int[] readArray() {
    Scanner in = new Scanner(System.in);    
    System.out.print("Length of the array: ");
    int size = in.nextInt();
    int[] a = new int[size];
    for (int i = 0; i < size; i++) {
       System.out.print("Insert the "+(i+1)+"-th value: ");
       a[i] = in.nextInt();
    }
    return a;   
  } 

  public static int binary_rec1(int a[], int l, int r, int v) {
      int res;
      if (l>r) 
	 res =  -1;
      else {
         int m = (l+r)/2;
System.out.print("l="+a[l]+" r="+a[r]+" pivot="+a[m]+ " ");
printSubArray(a,l,r); 
	 if (v==a[m])
	     res = m+1;
         else if (v<a[m]) 
             res = binary_rec1(a,l,m-1,v);
         else // (v>a[m]) 
             res = binary_rec1(a,m+1,r,v); 
      }
      return res;
  }

    public static int binary_rec(int a[], int v) {
	int l = 0,r = a.length-1;
	return binary_rec1(a,l,r,v);
    }
 


  public static void main(String args[]) {
    Scanner in = new Scanner(System.in);
    int a[] = readArray();
    printArray(a);
    int value = -1;
    do {
      int res = -1;
      System.out.print("Input the value to search (-1 to stop): ");
      value = in.nextInt();
      if (value >= 0) {
         res = binary_rec(a,value);
         if (res == -1)
            System.out.print("value not found");
         else
    	    System.out.print("value found in position "+res+"\n");
      }
    } while (value >= 0);
  }
}
